﻿<?xml version="1.0"?>
<xsl:stylesheet version="2.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:xdt="http://www.w3.org/2005/04/xpath-datatypes"
                xmlns:xs="http://www.w3.org/2001/XMLSchema"
                xmlns:f="http://fxsl.sf.net/"
                xmlns:int="http://fxsl.sf.net/internal/type"
                exclude-result-prefixes="f xs xdt int">

  <xsl:function name="int:type" as="xs:string">
    <xsl:param name="pThis"/>

    <xsl:choose>
      <xsl:when test="$pThis instance of xs:decimal">
        <xsl:choose>
          <xsl:when test="$pThis instance of xs:unsignedByte">xs:unsignedByte</xsl:when>
          <xsl:when test="$pThis instance of xs:unsignedShort">xs:unsignedShort</xsl:when>
          <xsl:when test="$pThis instance of xs:unsignedInt">xs:unsignedInt</xsl:when>
          <xsl:when test="$pThis instance of xs:unsignedLong">xs:unsignedLong</xsl:when>

          <xsl:when test="$pThis instance of xs:positiveInteger">xs:positiveInteger</xsl:when>
          <xsl:when test="$pThis instance of xs:nonNegativeInteger">xs:nonNegativeInteger</xsl:when>

          <xsl:when test="$pThis instance of xs:negativeInteger">xs:negativeInteger</xsl:when>
          <xsl:when test="$pThis instance of xs:nonPositiveInteger">xs:nonPositiveInteger</xsl:when>

          <xsl:when test="$pThis instance of xs:byte">xs:byte</xsl:when>
          <xsl:when test="$pThis instance of xs:short">xs:short</xsl:when>
          <xsl:when test="$pThis instance of xs:int">xs:int</xsl:when>
          <xsl:when test="$pThis instance of xs:long">xs:long</xsl:when>

          <xsl:when test="$pThis instance of xs:integer">xs:integer</xsl:when>

          <xsl:otherwise>xs:decimal</xsl:otherwise>

        </xsl:choose>
      </xsl:when>

      <xsl:when test="$pThis instance of xs:double">xs:double</xsl:when>
      <xsl:when test="$pThis instance of xs:float">xs:float</xsl:when>

      <xsl:when test="$pThis instance of xs:string">
        <xsl:choose>
          <xsl:when test="$pThis instance of xs:NMTOKEN">xs:NMTOKEN</xsl:when>

          <xsl:when test="$pThis instance of xs:ENTITY">xs:ENTITY</xsl:when>

          <xsl:when test="$pThis instance of xs:IDREF">xs:IDREF</xsl:when>

          <xsl:when test="$pThis instance of xs:ID">xs:ID</xsl:when>
          <xsl:when test="$pThis instance of xs:NCName">xs:NCName</xsl:when>
          <xsl:when test="$pThis instance of xs:Name">xs:Name</xsl:when>

          <xsl:when test="$pThis instance of xs:language">xs:language</xsl:when>
          <xsl:when test="$pThis instance of xs:token">xs:token</xsl:when>
          <xsl:when test="$pThis instance of xs:normalizedString">xs:normalizedString</xsl:when>

          <xsl:otherwise>xs:string</xsl:otherwise>
        </xsl:choose>
      </xsl:when>

      <xsl:when test="$pThis instance of xs:boolean">xs:boolean</xsl:when>

      <xsl:when test="$pThis instance of xs:dayTimeDuration">xs:dayTimeDuration</xsl:when>

      <xsl:when test="$pThis instance of xs:duration">xs:duration</xsl:when>

      <xsl:when test="$pThis instance of xs:dateTime">xs:dateTime</xsl:when>

      <xsl:when test="$pThis instance of xs:time">xs:time</xsl:when>

      <xsl:when test="$pThis instance of xs:date">xs:date</xsl:when>

      <xsl:when test="$pThis instance of xs:gYearMonth">xs:gYearMonth</xsl:when>

      <xsl:when test="$pThis instance of xs:gYear">xs:gYear</xsl:when>

      <xsl:when test="$pThis instance of xs:gMonthDay">xs:gMonthDay</xsl:when>

      <xsl:when test="$pThis instance of xs:gDay">xs:gDay</xsl:when>

      <xsl:when test="$pThis instance of xs:gMonth">xs:gMonth</xsl:when>

      <xsl:when test="$pThis instance of xs:base64Binary">xs:base64Binary</xsl:when>

      <xsl:when test="$pThis instance of xs:hexBinary">xs:hexBinary</xsl:when>

      <xsl:when test="$pThis instance of xs:anyURI">xs:anyURI</xsl:when>

      <xsl:when test="$pThis instance of xs:QName">xs:QName</xsl:when>

      <xsl:when test="$pThis instance of xs:NOTATION">xs:NOTATION</xsl:when>

      <xsl:when test="$pThis instance of xs:untypedAtomic">xs:untypedAtomic</xsl:when>
      <xsl:otherwise>Unknown xs:untypedAtomic</xsl:otherwise>
    </xsl:choose>
  </xsl:function>

</xsl:stylesheet>