﻿<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:ex="http://www.example.org"
                version="2.0">
 
    <xsl:output method="html"/>

    <xsl:template match="/">

        <html>
            <head>
                <title>Evaluating XPath Expresssions</title>
                <style type="text/css" media="all">
                    /* <![CDATA[ */
                   @import url(../css/basic.css);
                   /* ]]> */
                </style>
                <link rel="StyleSheet" href="../css/print.css" type="text/css" media="print" />
            </head>
            <body>
                <h1>Evaluating XPath Expresssions</h1>

                <table>
                    <tr>
                        <th>XPath</th>
                        <th>Result of XPath Evaluation</th>
                    </tr>
                    <tr>
                        <td>count(('a', 'b', (), 'c'))</td>
                        <td class="result">
                            <pre>
                                <xsl:value-of select="count(('a', 'b', (), 'c'))" />
                            </pre>
                        </td>
                    </tr>
                    <tr>
                        <td>('a', 'b', (), 'c')</td>
                        <td class="result">
                            <pre>
                                <xsl:value-of select="('a', 'b', (), 'c')" />
                            </pre>
                        </td>
                    </tr>
                    <tr>
                        <td>count(('a', 'b', '', 'c'))</td>
                        <td class="result">
                            <pre>
                                <xsl:value-of select="count(('a', 'b', '', 'c'))" />
                            </pre>
                        </td>
                    </tr>
                    <tr>
                        <td>('a', 'b', '', 'c')</td>
                        <td class="result">
                            <pre>
                                <xsl:value-of select="('a', 'b', '', 'c')" />
                            </pre>
                        </td>
                    </tr>
                    <tr>
                        <td>count((('a', 'b', '', 'c')[.]))</td>
                        <td class="result">
                            <pre>
                                <xsl:value-of select="count((('a', 'b', '', 'c')[.]))" />
                            </pre>
                        </td>
                    </tr>
                    <tr>
                        <td>('a', 'b', '', 'c')[.]</td>
                        <td class="result">
                            <pre>
                                <xsl:value-of select="('a', 'b', '', 'c')[.]" />
                            </pre>
                        </td>
                    </tr>
                </table>
            </body>
        </html>

    </xsl:template>


</xsl:stylesheet>