﻿<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:ex="http://www.example.org"
                version="2.0">
 
    <xsl:output method="html"/>

    <xsl:template match="/">

        <html>
            <head>
                <title>Evaluating XPath Expresssions</title>
                <style type="text/css" media="all">
                    /* <![CDATA[ */
                   @import url(../css/basic.css);
                   /* ]]> */
                </style>
                <link rel="StyleSheet" href="../css/print.css" type="text/css" media="print" />
            </head>
            <body>
                <h1>Evaluating XPath Expresssions</h1>

                <table>
                    <tr>
                        <th>XPath</th>
                        <th>Result of XPath Evaluation</th>
                    </tr>
                    <tr>
                        <td>insert-before((1,3,4,5,6,7,8,9),2,2)</td>
                        <td class="result">
                            <pre>
                                <xsl:value-of select="insert-before((1,3,4,5,6,7,8,9),2,2)" />
                            </pre>
                        </td>
                    </tr>
                    <tr>
                        <td>insert-before((1,3,4,5,6,7,8,9),1,2)</td>
                        <td class="result">
                            <pre>
                                <xsl:value-of select="insert-before((1,3,4,5,6,7,8,9),1,2)" />
                            </pre>
                        </td>
                    </tr>
                    <tr>
                        <td>insert-before((1,3,4,5,6,7,8,9),10,2)</td>
                        <td class="result">
                            <pre>
                                <xsl:value-of select="insert-before((1,3,4,5,6,7,8,9),10,2)" />
                            </pre>
                        </td>
                    </tr>
                    <tr>
                        <td>insert-before(('a','b','c','e'), 4, 'd')</td>
                        <td class="result">
                            <pre>
                                <xsl:value-of select="insert-before(('a','b','c','e'), 4, 'd')" />
                            </pre>
                        </td>
                    </tr>
                    <tr>
                        <td>insert-before(1 to 10, count(1 to 10) + 1, 2)</td>
                        <td class="result">
                            <pre>
                                <xsl:value-of select="insert-before(1 to 10, count(1 to 10) + 1, 2)" />
                            </pre>
                        </td>
                    </tr>
                    <tr>
                        <td>insert-before((1,3,4,5,6,7,8,9),2,(2,3))</td>
                        <td class="result">
                            <pre>
                                <xsl:value-of select="insert-before((1,3,4,5,6,7,8,9),2,(2,3))" />
                            </pre>
                        </td>
                    </tr>
                </table>
            </body>
        </html>

    </xsl:template>

    <xsl:template name="display">
      <xsl:param name="sequence"/>

      <xsl:for-each select="$sequence">
          <xsl:choose>
              <xsl:when test=". instance of node()">
                  <xsl:apply-templates select="." />
                  <xsl:text>
</xsl:text>
              </xsl:when>
              <xsl:otherwise>
                  <xsl:value-of select="."/>
                  <xsl:text>
</xsl:text>
              </xsl:otherwise>
          </xsl:choose>
      </xsl:for-each>
    </xsl:template>

    <xsl:template match="*">
        <xsl:text>&lt;</xsl:text><xsl:value-of select="name()"/><xsl:value-of separator="" select="for $i in @* return (' ', $i/name(), '=', '&quot;', $i, '&quot;')"/><xsl:text>&gt;</xsl:text>
            <xsl:apply-templates/>
        <xsl:text>&lt;/</xsl:text><xsl:value-of select="name()"/><xsl:text>&gt;</xsl:text>
    </xsl:template>



</xsl:stylesheet>