<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
                xmlns:xs="http://www.w3.org/2001/XMLSchema"
                xmlns:ex="http://www.example.org"
                version="2.0">
 
    <xsl:output method="html"/>

    <xsl:template match="/">

        <html>
            <head>
                <title>Evaluating XPath Expresssions</title>
                <style type="text/css" media="all">
                    /* <![CDATA[ */
                   @import url(../css/basic.css);
                   /* ]]> */
                </style>
                <link rel="StyleSheet" href="../css/print.css" type="text/css" media="print" />
            </head>
            <h1>Evaluating XPath Expresssions</h1>

            <table>
                <tr>
                    <th>XPath</th>
                    <th>Result of XPath Evaluation</th>
                </tr>
                <tr>
                    <td>for $i in //element(Member) return $i/Name</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="for $i in //element(Member) return $i/Name" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>for $i in //Member return $i/Name</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="for $i in //Member return $i/Name" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>for $i in //element(Member) return $i instance of element(Member)</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="for $i in //element(Member) return $i instance of element(Member)" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>for $i in //element() return name($i)</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="for $i in //element() return name($i)" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>for $i in //* return name($i)</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="for $i in //* return name($i)" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>for $i in //node() return name($i)</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="for $i in //node() return name($i)" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>for $i in //text() return $i</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="for $i in //text() return $i" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>/ instance of document-node()</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="/ instance of document-node()" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>/FitnessCenter instance of element()</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="/FitnessCenter instance of element()" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>/* instance of element(FitnessCenter)</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="/* instance of element(FitnessCenter)" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>/FitnessCenter/Member[1]/@id instance of attribute()</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="/FitnessCenter/Member[1]/@id instance of attribute()" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>/FitnessCenter/Member[1]/@id instance of attribute(id)</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="/FitnessCenter/Member[1]/@id instance of attribute(id)" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>/FitnessCenter/Member[999] instance of empty-sequence()</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="/FitnessCenter/Member[999] instance of empty-sequence()" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>/FitnessCenter/Member[1]/MembershipFee/node() instance of text()</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="/FitnessCenter/Member[1]/MembershipFee/node() instance of text()" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>(//MembershipFee)[1] instance of element()</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="(//MembershipFee)[1] instance of element()" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>//MembershipFee[1] instance of element()</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="//MembershipFee[1] instance of element()" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>//MembershipFee[1] instance of element()+</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="//MembershipFee[1] instance of element()+" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>FitnessCenter/Member instance of element()</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="FitnessCenter/Member instance of element()" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>FitnessCenter/Member instance of element()+</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="FitnessCenter/Member instance of element()+" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
            </table>
        </html>

    </xsl:template>

    <xsl:template name="display">
      <xsl:param name="sequence"/>

      <xsl:for-each select="$sequence">
          <xsl:choose>
              <xsl:when test=". instance of node()">
                  <xsl:apply-templates select="." />
                  <xsl:text>
</xsl:text>
              </xsl:when>
              <xsl:otherwise>
                  <xsl:value-of select="."/>
                  <xsl:text>
</xsl:text>
              </xsl:otherwise>
          </xsl:choose>
      </xsl:for-each>
    </xsl:template>

    <xsl:template match="*">
        <xsl:text>&lt;</xsl:text><xsl:value-of select="name()"/><xsl:value-of separator="" select="for $i in @* return (' ', $i/name(), '=', '&quot;', $i, '&quot;')"/><xsl:text>&gt;</xsl:text>
            <xsl:apply-templates/>
        <xsl:text>&lt;/</xsl:text><xsl:value-of select="name()"/><xsl:text>&gt;</xsl:text>
    </xsl:template>


</xsl:stylesheet>