﻿<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:ex="http://www.example.org"
                version="2.0">
 
    <xsl:output method="html"/>

    <xsl:template match="/">

        <html>
            <head>
                <title>Evaluating XPath Expresssions</title>
                <style type="text/css" media="all">
                    /* <![CDATA[ */
                   @import url(../css/basic.css);
                   /* ]]> */
                </style>
                <link rel="StyleSheet" href="../css/print.css" type="text/css" media="print" />
            </head>
            <body>
                <h1>Evaluating XPath Expresssions</h1>

                <table>
                    <tr>
                        <th>XPath</th>
                        <th>Result of XPath Evaluation</th>
                    </tr>
                    <tr>
                        <td>//planet[mass = .815] &gt;&gt; //planet[mass =.0553]</td>
                        <td class="result">
                            <pre>
                                <xsl:call-template name="display"> 
                                    <xsl:with-param name="sequence" select="//planet[mass = .815] &gt;&gt; //planet[mass =.0553]" />
                                </xsl:call-template>
                            </pre>
                        </td>
                    </tr>
                </table>

<h2>The XML Document</h2>
<pre>
<xsl:apply-templates />
</pre>
            </body>
        </html>

    </xsl:template>

    <xsl:template name="display">
      <xsl:param name="sequence"/>

      <xsl:for-each select="$sequence">
          <xsl:choose>
              <xsl:when test=". instance of node()">
                  <xsl:apply-templates select="." />
                  <xsl:text>
</xsl:text>
              </xsl:when>
              <xsl:otherwise>
                  <xsl:value-of select="."/>
                  <xsl:text>
</xsl:text>
              </xsl:otherwise>
          </xsl:choose>
      </xsl:for-each>
    </xsl:template>

    <xsl:template match="*">
        <xsl:text>&lt;</xsl:text><xsl:value-of select="name()"/><xsl:value-of separator="" select="for $i in @* return (' ', $i/name(), '=', '&quot;', $i, '&quot;')"/><xsl:text>&gt;</xsl:text>
            <xsl:apply-templates/>
        <xsl:text>&lt;/</xsl:text><xsl:value-of select="name()"/><xsl:text>&gt;</xsl:text>
    </xsl:template>


</xsl:stylesheet>