﻿<?xml version="1.0"?>
<xsl:stylesheet version="2.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:xdt="http://www.w3.org/2005/04/xpath-datatypes"
                xmlns:xs="http://www.w3.org/2001/XMLSchema"
                xmlns:f="http://fxsl.sf.net/"
                xmlns:int="http://fxsl.sf.net/internal/type"
                exclude-result-prefixes="f xs xdt int">

    <xsl:import href="../datatype-evaluator/datatype-evaluator.xsl" />
 
    <xsl:output method="html"/>

    <xsl:template match="/">

        <html>
            <head>
                <title>Evaluating XPath Expresssions</title>
                <style type="text/css" media="all">
                    /* <![CDATA[ */
                   @import url(../css/basic.css);
                   /* ]]> */
                </style>
                <link rel="StyleSheet" href="../css/print.css" type="text/css" media="print" />
            </head>
            <body>
                <h1>Evaluating XPath Expresssions</h1>

                <table>
                    <tr>
                        <th>XPath</th>
                        <th>Result of XPath Evaluation</th>
                    </tr>
                    <tr>
                        <td>datatype of current-dateTime() - xs:dateTime('1970-01-01T00:00:00Z')</td>
                        <td class="result">
                            <pre>
                                <xsl:value-of select="int:type(current-dateTime() - xs:dateTime('1970-01-01T00:00:00Z'))" />
                            </pre>
                        </td>
                    </tr>
                    <tr>
                        <td>datatype of current-date() - xs:date('1970-01-01')</td>
                        <td class="result">
                            <pre>
                                <xsl:value-of select="int:type(current-date() - xs:date('1970-01-01'))" />
                            </pre>
                        </td>
                    </tr>
                    <tr>
                        <td>datatype of 3</td>
                        <td class="result">
                            <pre>
                                <xsl:value-of select="int:type(3)" />
                            </pre>
                        </td>
                    </tr>
                    <tr>
                        <td>datatype of 3.14</td>
                        <td class="result">
                            <pre>
                                <xsl:value-of select="int:type(3.14)" />
                            </pre>
                        </td>
                    </tr>
                    <tr>
                        <td>datatype of "3"</td>
                        <td class="result">
                            <pre>
                                <xsl:value-of select="int:type('3')" />
                            </pre>
                        </td>
                    </tr>
                    <tr>
                        <td>datatype of true</td>
                        <td class="result">
                            <pre>
                                <xsl:value-of select="int:type(true)" />
                            </pre>
                        </td>
                    </tr>
                    <tr>
                        <td>datatype of true()</td>
                        <td class="result">
                            <pre>
                                <xsl:value-of select="int:type(true())" />
                            </pre>
                        </td>
                    </tr>
                    <tr>
                        <td>datatype of 1E3</td>
                        <td class="result">
                            <pre>
                                <xsl:value-of select="int:type(1E3)" />
                            </pre>
                        </td>
                    </tr>
                </table>
            </body>
        </html>

    </xsl:template>

</xsl:stylesheet>