<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:ex="http://www.example.org"
                version="2.0">
 
    <xsl:output method="html"/>

    <xsl:template match="/">

        <html>
            <head>
                <title>Evaluating XPath Expresssions</title>
                <style type="text/css" media="all">
                    /* <![CDATA[ */
                   @import url(../css/basic.css);
                   /* ]]> */
                </style>
                <link rel="StyleSheet" href="../css/print.css" type="text/css" media="print" />
            </head>
            <h1>Evaluating XPath Expresssions</h1>

            <table>
                <tr>
                    <th>XPath</th>
                    <th>Result of XPath Evaluation</th>
                </tr>
                <tr>
                    <td>contains('abc', 'b')</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="contains('abc', 'b')" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>contains(/FitnessCenter/Member[1]/FavoriteColor, 'light')</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="contains(/FitnessCenter/Member[1]/FavoriteColor, 'light')" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>substring('1234567890', 3, 5)</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="substring('1234567890', 3, 5)" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>substring(/FitnessCenter/Member[1]/FavoriteColor, 6)</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="substring(/FitnessCenter/Member[1]/FavoriteColor, 6)" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>substring-before('Hello World', ' ')</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="substring-before('Hello World', ' ')" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>substring-after('Hello World', ' ')</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="substring-after('Hello World', ' ')" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>translate('Hello World', 'abcdefghijklmnopqrstuvwxyz ', 'ABCDEFGHIJKLMNOPQRSTUVWXYZ ')</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="translate('Hello World', 'abcdefghijklmnopqrstuvwxyz ', 'ABCDEFGHIJKLMNOPQRSTUVWXYZ ')" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
            </table>

<h2>The XML Document</h2>
<pre>
<xsl:apply-templates />
</pre>
        </html>

    </xsl:template>

    <xsl:template name="display">
      <xsl:param name="sequence"/>

      <xsl:for-each select="$sequence">
          <xsl:choose>
              <xsl:when test=". instance of node()">
                  <xsl:apply-templates select="." />
                  <xsl:text>
</xsl:text>
              </xsl:when>
              <xsl:otherwise>
                  <xsl:value-of select="."/>
                  <xsl:text>
</xsl:text>
              </xsl:otherwise>
          </xsl:choose>
      </xsl:for-each>
    </xsl:template>

    <xsl:template match="*">
        <xsl:text>&lt;</xsl:text><xsl:value-of select="name()"/><xsl:value-of separator="" select="for $i in @* return (' ', $i/name(), '=', '&quot;', $i, '&quot;')"/><xsl:text>&gt;</xsl:text>
            <xsl:apply-templates/>
        <xsl:text>&lt;/</xsl:text><xsl:value-of select="name()"/><xsl:text>&gt;</xsl:text>
    </xsl:template>


</xsl:stylesheet>