<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
                xmlns:xs="http://www.w3.org/2001/XMLSchema"
                xmlns:ex="http://www.example.org"
                version="2.0">
 
    <xsl:output method="html"/>

    <xsl:template match="/">

        <html>
            <head>
                <title>Evaluating XPath Expresssions</title>
                <style type="text/css" media="all">
                    /* <![CDATA[ */
                   @import url(../css/basic.css);
                   /* ]]> */
                </style>
                <link rel="StyleSheet" href="../css/print.css" type="text/css" media="print" />
            </head>
            <h1>Evaluating XPath Expresssions</h1>

            <table>
                <tr>
                    <th>XPath</th>
                    <th>Result of XPath Evaluation</th>
                </tr>
                <tr>
                    <td>year-from-dateTime(xs:dateTime('2009-09-19T11:42:00-04:00'))</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="year-from-dateTime(xs:dateTime('2009-09-19T11:42:00-04:00'))" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>month-from-dateTime(xs:dateTime('2009-09-19T11:42:00-04:00'))</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="month-from-dateTime(xs:dateTime('2009-09-19T11:42:00-04:00'))" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>day-from-dateTime(xs:dateTime('2009-09-19T11:42:00-04:00'))</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="day-from-dateTime(xs:dateTime('2009-09-19T11:42:00-04:00'))" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>hours-from-dateTime(xs:dateTime('2009-09-19T11:42:00-04:00'))</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="hours-from-dateTime(xs:dateTime('2009-09-19T11:42:00-04:00'))" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>minutes-from-dateTime(xs:dateTime('2009-09-19T11:42:00-04:00'))</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="minutes-from-dateTime(xs:dateTime('2009-09-19T11:42:00-04:00'))" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>seconds-from-dateTime(xs:dateTime('2009-09-19T11:42:00-04:00'))</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="seconds-from-dateTime(xs:dateTime('2009-09-19T11:42:00-04:00'))" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>timezone-from-dateTime(xs:dateTime('2009-09-19T11:42:00-04:00'))</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="timezone-from-dateTime(xs:dateTime('2009-09-19T11:42:00-04:00'))" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>year-from-date(xs:date('2009-09-19-04:00'))</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="year-from-date(xs:date('2009-09-19-04:00'))" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>month-from-date(xs:date('2009-09-19-04:00'))</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="month-from-date(xs:date('2009-09-19-04:00'))" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>day-from-date(xs:date('2009-09-19-04:00'))</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="day-from-date(xs:date('2009-09-19-04:00'))" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>timezone-from-date(xs:date('2009-09-19-04:00'))</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="timezone-from-date(xs:date('2009-09-19-04:00'))" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>hours-from-time(xs:time('11:42:00-04:00'))</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="hours-from-time(xs:time('11:42:00-04:00'))" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>minutes-from-time(xs:time('11:42:00-04:00'))</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="minutes-from-time(xs:time('11:42:00-04:00'))" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>seconds-from-time(xs:time('11:42:00-04:00'))</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="seconds-from-time(xs:time('11:42:00-04:00'))" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
                <tr>
                    <td>timezone-from-time(xs:time('11:42:00-04:00'))</td>
                    <td class="result">
                        <pre>
                            <xsl:call-template name="display"> 
                                <xsl:with-param name="sequence" select="timezone-from-time(xs:time('11:42:00-04:00'))" />
                            </xsl:call-template>
                        </pre>
                    </td>
                </tr>
            </table>
        </html>

    </xsl:template>

    <xsl:template name="display">
      <xsl:param name="sequence"/>

      <xsl:for-each select="$sequence">
          <xsl:choose>
              <xsl:when test=". instance of node()">
                  <xsl:apply-templates select="." />
                  <xsl:text>
</xsl:text>
              </xsl:when>
              <xsl:otherwise>
                  <xsl:value-of select="."/>
                  <xsl:text>
</xsl:text>
              </xsl:otherwise>
          </xsl:choose>
      </xsl:for-each>
    </xsl:template>

    <xsl:template match="*">
        <xsl:text>&lt;</xsl:text><xsl:value-of select="name()"/><xsl:value-of separator="" select="for $i in @* return (' ', $i/name(), '=', '&quot;', $i, '&quot;')"/><xsl:text>&gt;</xsl:text>
            <xsl:apply-templates/>
        <xsl:text>&lt;/</xsl:text><xsl:value-of select="name()"/><xsl:text>&gt;</xsl:text>
    </xsl:template>


</xsl:stylesheet>